//
//  Spikes.h
//  Neuron1
//
// Object to use for archiving and unarchiving the spikes generated by a run of the simulator
//
//  Created by Leslie Smith on 21/09/2004.
//  Copyright 2004 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "SpikeArray.h"


@interface Spikes : NSObject <NSCoding> {
	SpikeArray *SpikesStored ;
	NSMutableDictionary *GeneratingParams ;	
}

- (id) initWithSpikeArrayAndParams: (SpikeArray *) SpikesForStoring params: (NSMutableDictionary *) GenParams ;

- (id) initWithCoder: (NSCoder *) coder ;
- (void) encodeWithCoder: (NSCoder *) coder ;

- (void) setSpikesArray: (SpikeArray *) SpikeObject ;
- (SpikeArray *) returnSpikeArrayObject ;
- (void) setGeneratingParams: (NSMutableDictionary *) GenParams ;
- (NSMutableDictionary *) getGeneratingParams ;
- (void) saveSpikesHumanReadable: (NSString *) FileName ;

@end
