// syndata.h: data type definition for description of a synapse
// set in to a seperate file because used in a number of places
//
// LSS, 6 Aug 2004

typedef struct syndata syndatatype ;
typedef syndatatype *syndataptr ;

struct syndata // synapse data holding structure
{
	char synapsetype[5] ;
	int presyn;
	int postsyn ;
	int syntype ; // not used currently
	float weight ;
	float alpha ;
	float rechargerate ;
	float utilrate ;
	float delay ;
	BOOL resetinputonpresynspike ;
	syndataptr nextsyn ;
} ; 

// structure to keep together the characteristics of the adaptivity

typedef struct STDP STDPinfo ;

struct STDP
{
	BOOL prepostNN ; // YES if pre->post is nearest neighbour
	BOOL postpreNN ; // YES if post->pre is nearest neighbour
	BOOL LTPwinner ; // YES if LTP wins (and so stops LTD)
	BOOL prepostadditive ; // YES if the pre->post effect on the weight is additive (otherwise multiplicative)
	BOOL postpreadditive ; // YES if the post-pre effect on the weight is additive (otherwise multiplicative)
	BOOL antihebbianforinhibitory ; // YES if adaptation is to be antihebbian for inhibitory synapses
	BOOL zxpermitted; // YES if weights can change sign, NO if not.
	BOOL zeroabsorbing ; // YES if weights cease to be adaptive when they hit 0. Only tested if zxpermitted = NO
	BOOL excitatory ; // set to YES if initial weight >= 0
	float prepostTau ;
	float postpreTau ;
	float prepostDeltaWeight ;
	float postpreDeltaWeight ;
	float maxallowedweight ;
	float minallowedweight ;
} ;